{
    "$graph": [
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "registry.gitlab.com/uc-cdis/genomel-exome-variant-detection/genomel_variant_calling:6.0"
                }
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File",
                        "inputBinding": {
                            "prefix": "-b"
                        }
                    },
                    "inputBinding": {
                        "position": 0
                    },
                    "id": "#extract_pass_pair.cwl/bed_files"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-l",
                        "position": 2
                    },
                    "id": "#extract_pass_pair.cwl/log_file"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File",
                        "inputBinding": {
                            "prefix": "-v"
                        }
                    },
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#extract_pass_pair.cwl/vcf_files"
                }
            ],
            "baseCommand": [
                "python",
                "/opt/extract_pass_pair.py"
            ],
            "id": "#extract_pass_pair.cwl",
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.bed"
                    },
                    "id": "#extract_pass_pair.cwl/passed_bed_list"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.vcf"
                    },
                    "id": "#extract_pass_pair.cwl/passed_vcf_list"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "registry.gitlab.com/uc-cdis/genomel-exome-variant-detection/genomel_variant_calling:6.0"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 21
                }
            ],
            "successCodes": [
                0,
                1
            ],
            "inputs": [
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "id": "#aws_freebayes.cwl/bam"
                },
                {
                    "type": "File",
                    "id": "#aws_freebayes.cwl/bed_file"
                },
                {
                    "type": "string",
                    "id": "#aws_freebayes.cwl/job_uuid"
                },
                {
                    "type": "int",
                    "id": "#aws_freebayes.cwl/number_of_chunks"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "id": "#aws_freebayes.cwl/reference"
                },
                {
                    "type": "int",
                    "id": "#aws_freebayes.cwl/thread_count"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.bed"
                    },
                    "id": "#aws_freebayes.cwl/bed_list"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.pdc_freebayes_docker.log"
                    },
                    "id": "#aws_freebayes.cwl/log_file"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.job_uuid + '.aws_freebayes.time.json')"
                    },
                    "id": "#aws_freebayes.cwl/time_metrics"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.vcf"
                    },
                    "id": "#aws_freebayes.cwl/vcf_list"
                }
            ],
            "baseCommand": [],
            "arguments": [
                {
                    "position": 0,
                    "shellQuote": false,
                    "valueFrom": "/usr/bin/time -f \"{\\\\\"real_time\\\\\": \\\\\"%E\\\\\", \\\\\"user_time\\\\\": %U, \\\\\"system_time\\\\\": %S, \\\\\"wall_clock\\\\\": %e, \\\\\"maximum_resident_set_size\\\\\": %M, \\\\\"average_total_mem\\\\\": %K, \\\\\"percent_of_cpu\\\\\": \\\\\"%P\\\\\"}\" -o $(inputs.job_uuid + '.aws_freebayes.time.json') python /opt/aws_freebayes.py -b $(inputs.bam.path) -j $(inputs.job_uuid) -f $(inputs.reference.path) -t $(inputs.bed_file.path) -n $(inputs.thread_count) -c $(inputs.number_of_chunks)"
                }
            ],
            "id": "#aws_freebayes.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "registry.gitlab.com/uc-cdis/genomel-exome-variant-detection/genomel_variant_calling:6.0"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#gatk3_selectvariants.cwl/input_vcf"
                },
                {
                    "type": "string",
                    "id": "#gatk3_selectvariants.cwl/job_uuid"
                },
                {
                    "type": "string",
                    "id": "#gatk3_selectvariants.cwl/output_prefix"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "id": "#gatk3_selectvariants.cwl/reference"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_prefix + '.filtered.site_only.vcf.gz')"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#gatk3_selectvariants.cwl/output_vcf"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.job_uuid + '.gatk3_selectvariants.time.json')"
                    },
                    "id": "#gatk3_selectvariants.cwl/time_metrics"
                }
            ],
            "baseCommand": [],
            "arguments": [
                {
                    "position": 0,
                    "shellQuote": false,
                    "valueFrom": "/usr/bin/time -f \"{\\\\\"real_time\\\\\": \\\\\"%E\\\\\", \\\\\"user_time\\\\\": %U, \\\\\"system_time\\\\\": %S, \\\\\"wall_clock\\\\\": %e, \\\\\"maximum_resident_set_size\\\\\": %M, \\\\\"average_total_mem\\\\\": %K, \\\\\"percent_of_cpu\\\\\": \\\\\"%P\\\\\"}\" -o $(inputs.job_uuid + '.gatk3_selectvariants.time.json') java -Xmx100G -XX:ParallelGCThreads=30 -jar /opt/GenomeAnalysisTK.jar -T SelectVariants --variant $(inputs.input_vcf.path) -R $(inputs.reference.path) -o $(inputs.output_prefix + '.filtered.site_only.vcf.gz') -select \"QUAL > 20.0\" -ef -env"
                }
            ],
            "id": "#gatk3_selectvariants.cwl"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "registry.gitlab.com/uc-cdis/genomel-exome-variant-detection/genomel_variant_calling:6.0"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#picard_sortvcf.cwl/job_uuid"
                },
                {
                    "type": "string",
                    "id": "#picard_sortvcf.cwl/output_prefix"
                },
                {
                    "type": "File",
                    "id": "#picard_sortvcf.cwl/reference_dict"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File",
                        "inputBinding": {
                            "prefix": "I=",
                            "separate": false
                        }
                    },
                    "inputBinding": {
                        "position": 99
                    },
                    "id": "#picard_sortvcf.cwl/vcf"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.job_uuid + '.' + inputs.output_prefix + '.vcf.gz')"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#picard_sortvcf.cwl/sorted_vcf"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.job_uuid + '.picard_sortvcf.time.json')"
                    },
                    "id": "#picard_sortvcf.cwl/time_metrics"
                }
            ],
            "baseCommand": [],
            "arguments": [
                {
                    "position": 0,
                    "shellQuote": false,
                    "valueFrom": "/usr/bin/time -f \"{\\\\\"real_time\\\\\": \\\\\"%E\\\\\", \\\\\"user_time\\\\\": %U, \\\\\"system_time\\\\\": %S, \\\\\"wall_clock\\\\\": %e, \\\\\"maximum_resident_set_size\\\\\": %M, \\\\\"average_total_mem\\\\\": %K, \\\\\"percent_of_cpu\\\\\": \\\\\"%P\\\\\"}\" -o $(inputs.job_uuid + '.picard_sortvcf.time.json') java -Xmx100G -XX:ParallelGCThreads=30 -jar /opt/picard.jar SortVcf CREATE_INDEX=true OUTPUT=$(inputs.job_uuid + '.' + inputs.output_prefix + '.vcf.gz') SEQUENCE_DICTIONARY=$(inputs.reference_dict.path)"
                }
            ],
            "id": "#picard_sortvcf.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "secondaryFiles": [
                        "^.bai"
                    ],
                    "id": "#main/bam"
                },
                {
                    "type": "File",
                    "id": "#main/bed_file"
                },
                {
                    "type": "string",
                    "id": "#main/job_uuid"
                },
                {
                    "type": "int",
                    "id": "#main/number_of_chunks"
                },
                {
                    "type": "string",
                    "id": "#main/output_prefix"
                },
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "id": "#main/reference"
                },
                {
                    "type": "int",
                    "id": "#main/thread_count"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/gatk3_selectvariants/output_vcf",
                    "id": "#main/freebayes_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#main/aws_freebayes/log_file",
                    "id": "#main/log_file"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/extract_pass_pair/passed_bed_list",
                    "id": "#main/passed_bed"
                },
                {
                    "type": "File",
                    "outputSource": "#main/aws_freebayes/time_metrics",
                    "id": "#main/time_metrics_from_freebayes"
                },
                {
                    "type": "File",
                    "outputSource": "#main/picard_sortvcf/time_metrics",
                    "id": "#main/time_metrics_from_picard_sortvcf"
                },
                {
                    "type": "File",
                    "outputSource": "#main/gatk3_selectvariants/time_metrics",
                    "id": "#main/time_metrics_from_selectvariants"
                }
            ],
            "steps": [
                {
                    "run": "#aws_freebayes.cwl",
                    "in": [
                        {
                            "source": "#main/bam",
                            "id": "#main/aws_freebayes/bam"
                        },
                        {
                            "source": "#main/bed_file",
                            "id": "#main/aws_freebayes/bed_file"
                        },
                        {
                            "source": "#main/job_uuid",
                            "id": "#main/aws_freebayes/job_uuid"
                        },
                        {
                            "source": "#main/number_of_chunks",
                            "id": "#main/aws_freebayes/number_of_chunks"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/aws_freebayes/reference"
                        },
                        {
                            "source": "#main/thread_count",
                            "id": "#main/aws_freebayes/thread_count"
                        }
                    ],
                    "out": [
                        "#main/aws_freebayes/vcf_list",
                        "#main/aws_freebayes/bed_list",
                        "#main/aws_freebayes/log_file",
                        "#main/aws_freebayes/time_metrics"
                    ],
                    "id": "#main/aws_freebayes"
                },
                {
                    "run": "#extract_pass_pair.cwl",
                    "in": [
                        {
                            "source": "#main/aws_freebayes/bed_list",
                            "id": "#main/extract_pass_pair/bed_files"
                        },
                        {
                            "source": "#main/aws_freebayes/log_file",
                            "id": "#main/extract_pass_pair/log_file"
                        },
                        {
                            "source": "#main/aws_freebayes/vcf_list",
                            "id": "#main/extract_pass_pair/vcf_files"
                        }
                    ],
                    "out": [
                        "#main/extract_pass_pair/passed_vcf_list",
                        "#main/extract_pass_pair/passed_bed_list"
                    ],
                    "id": "#main/extract_pass_pair"
                },
                {
                    "run": "#gatk3_selectvariants.cwl",
                    "in": [
                        {
                            "source": "#main/picard_sortvcf/sorted_vcf",
                            "id": "#main/gatk3_selectvariants/input_vcf"
                        },
                        {
                            "source": "#main/job_uuid",
                            "id": "#main/gatk3_selectvariants/job_uuid"
                        },
                        {
                            "source": [
                                "#main/job_uuid",
                                "#main/output_prefix"
                            ],
                            "valueFrom": "$(self[0] + '.' + self[1] + '.freebayes')",
                            "id": "#main/gatk3_selectvariants/output_prefix"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/gatk3_selectvariants/reference"
                        }
                    ],
                    "out": [
                        "#main/gatk3_selectvariants/output_vcf",
                        "#main/gatk3_selectvariants/time_metrics"
                    ],
                    "id": "#main/gatk3_selectvariants"
                },
                {
                    "run": "#picard_sortvcf.cwl",
                    "in": [
                        {
                            "source": "#main/job_uuid",
                            "id": "#main/picard_sortvcf/job_uuid"
                        },
                        {
                            "source": "#main/output_prefix",
                            "valueFrom": "$(self + '.srt')",
                            "id": "#main/picard_sortvcf/output_prefix"
                        },
                        {
                            "source": "#main/reference",
                            "valueFrom": "$(self.secondaryFiles[1])",
                            "id": "#main/picard_sortvcf/reference_dict"
                        },
                        {
                            "source": "#main/extract_pass_pair/passed_vcf_list",
                            "id": "#main/picard_sortvcf/vcf"
                        }
                    ],
                    "out": [
                        "#main/picard_sortvcf/sorted_vcf",
                        "#main/picard_sortvcf/time_metrics"
                    ],
                    "id": "#main/picard_sortvcf"
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
